unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, IdBaseComponent, IdComponent, IdUDPBase,
  IdUDPClient, IdSocketHandle, Sockets, IdUDPServer, inifiles, Menus,
  ComCtrls, OoMisc, AdPort, IdTCPConnection, IdTCPClient, IdTCPServer,
  IdRawBase, IdRawClient, IdIcmpClient, AdStatLt;

type
  tascii_name = record
    name: string[3];
    value:byte;
  end;

  TCommThread = class(TThread)
      private
        FText: string;
      protected
        procedure Execute; override;
        //this will hold the result of the communication
        property Text: string read FText;
      end;


  TForm1 = class(TForm)
    Timer1: TTimer;
    IdUDPServer1: TIdUDPServer;
    PopupMenu1: TPopupMenu;
    Npovda1: TMenuItem;
    Oprogramu1: TMenuItem;
    ApdComPort1: TApdComPort;
    IdTCPServer1: TIdTCPServer;
    IdTCPClient1: TIdTCPClient;
    IdIcmpClient1: TIdIcmpClient;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    pravy1: TMenuItem;
    Hledej1: TMenuItem;
    Okna1: TMenuItem;
    Npovda2: TMenuItem;
    Npovda3: TMenuItem;
    Oprogramu2: TMenuItem;
    ComboBox_pripojeni: TComboBox;
    Panel_RS: TPanel;
    ComboBox_COM_port: TComboBox;
    Button_detect: TButton;
    ComboBox_baud: TComboBox;
    ComboBox_bits: TComboBox;
    ComboBox_parity: TComboBox;
    ComboBox_stop: TComboBox;
    Button_RS232_On: TButton;
    Panel_TCP_S: TPanel;
    Label3: TLabel;
    Edit_TCP_S_port: TEdit;
    Button_TCP_S_On: TButton;
    Panel_TCP_C: TPanel;
    Button_TCP_C_On: TButton;
    Label11: TLabel;
    Edit_tcp_k_addr: TEdit;
    Label2: TLabel;
    Edit_tcp_k_port: TEdit;
    Makrakodesln1: TMenuItem;
    Pijmacfiltry1: TMenuItem;
    Stavyadata1: TMenuItem;
    Pijatdata1: TMenuItem;
    Odeslandata1: TMenuItem;
    Panel_UDP: TPanel;
    Label4: TLabel;
    Edit_tx_adr: TEdit;
    Label5: TLabel;
    Edit_tx_port: TEdit;
    Label7: TLabel;
    Edit_rx_port: TEdit;
    Button_UDP_On: TButton;
    Panel_ICMP: TPanel;
    Label13: TLabel;
    Edit_icmp_a: TEdit;
    Button_ICMP_On: TButton;
    Timer_rx: TTimer;
    Otevtnastaven1: TMenuItem;
    Ulozitnastaven1: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure Timer1Timer(Sender: TObject);
    procedure IdUDPServer1UDPRead(Sender: TObject; AData: TStream;
      ABinding: TIdSocketHandle);
    procedure Button_tx_showClick(Sender: TObject);
    procedure Button_UDP_OnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function wildtostr(si:string):string;
    function hextostr(si:string):string;
    procedure Button3Click(Sender: TObject);
    procedure Npovda1Click(Sender: TObject);
    procedure Oprogramu1Click(Sender: TObject);
    procedure Button_RX_filtrClick(Sender: TObject);
    procedure IdTCPServer1Connect(AThread: TIdPeerThread);
    procedure IdTCPServer1Disconnect(AThread: TIdPeerThread);
    procedure Button_ICMP_OnClick(Sender: TObject);
    procedure Button_TCP_S_OnClick(Sender: TObject);
    procedure IdTCPClient1Connected(Sender: TObject);
    procedure IdTCPClient1Disconnected(Sender: TObject);
    procedure ApdComPort1PortClose(Sender: TObject);
    procedure ApdComPort1PortOpen(Sender: TObject);
    procedure ApdComPort1TriggerAvail(CP: TObject; Count: Word);
    procedure FormShow(Sender: TObject);
    procedure Npovda3Click(Sender: TObject);
    procedure Oprogramu2Click(Sender: TObject);
    procedure Button_RS232_OnClick(Sender: TObject);
    procedure Button_detectClick(Sender: TObject);
    procedure Button_TCP_C_OnClick(Sender: TObject);
    procedure Makrakodesln1Click(Sender: TObject);
    procedure Pijmacfiltry1Click(Sender: TObject);
    procedure Stavyadata1Click(Sender: TObject);
    procedure ComboBox_pripojeniChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer_rxTimer(Sender: TObject);
    procedure IdIcmpClient1Reply(ASender: TComponent;
      const AReplyStatus: TReplyStatus);
    procedure IdTCPServer1Execute(AThread: TIdPeerThread);
    procedure Pijatdata1Click(Sender: TObject);
    procedure Odeslandata1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Otevtnastaven1Click(Sender: TObject);
    procedure Ulozitnastaven1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    setup_done:boolean;
    ICMP_connected: boolean;
    ETHThread: TCommThread;
    eth_thread_running:boolean;
    kill_eth:boolean;
    semafor_stop_rx:boolean;
    rx_buff:string;
    old_length_rx_buff:integer;

    idtcp_thread: TIdPeerThread;

    ini_filename: string;
    verze_ini:string;

    procedure Parse_RX(s: string; z:string);

    Procedure RS232_Disconnect;
    Procedure RS232_Connect;
    Procedure TCP_S_Disconnect;
    Procedure TCP_S_Connect;
    Procedure TCP_C_Disconnect;
    Procedure TCP_C_Connect;
    Procedure UDP_Disconnect;
    Procedure UDP_Connect;
    Procedure ICMP_Disconnect;
    Procedure ICMP_Connect;

    procedure Run_ETH_Thread(Sender: TObject);

    procedure saveconfig;

  end;

const verze_sw='0.5';

var
  Form1: TForm1;

      const ascii_names :array[0..31] of tascii_name=(
(name:'nul';value:0),
(name:'soh';value:1),
(name:'stx';value:2),
(name:'etx';value:3),
(name:'eot';value:4),
(name:'enq';value:5),
(name:'ack';value:6),
(name:'bel';value:7),
(name:'bs';value:8),
(name:'tab';value:9),

(name:'lf';value:10),
(name:'vt';value:11),
(name:'ff';value:12),
(name:'cr';value:13),
(name:'so';value:14),
(name:'si';value:15),
(name:'dle';value:16),
(name:'dc1';value:17),
(name:'dc2';value:18),
(name:'dc3';value:19),

(name:'dc4';value:20),
(name:'nak';value:21),
(name:'syn';value:22),
(name:'etb';value:23),
(name:'can';value:24),
(name:'em';value:25),
(name:'sub';value:26),
(name:'esc';value:27),
(name:'fs';value:28),
(name:'gs';value:29),

(name:'rs';value:30),
(name:'us';value:31)

);

implementation

uses Unit_tx, Unit_frame_main, Unit_frame_tx, Unit_help,
  Unit_about, Unit_rx_filtr, Unit_frame_filtr, StrUtils, Unit_rx_TX,
  Unit_rxw, Unit_TXW;

{$R *.dfm}


procedure TForm1.Timer1Timer(Sender: TObject);
var i:integer;
s: string[100];
begin

  
//  i:=idudpclient1.Binding
//  memo1.Lines.Add(idudpclient1.ReceiveString());
end;

procedure tform1.UDP_Connect;
begin
  ComboBox_pripojeni.Enabled:=false;

      Edit_tx_adr.Enabled:=false;
      Edit_tx_port.Enabled:=false;
      Edit_rx_port.Enabled:=false;

      label4.Enabled:=false;
      label5.Enabled:=false;

      label7.Enabled:=false;

      IdUDPServer1.Active:=false;

      IdUDPServer1.defaultport:=strtoint(Edit_rx_port.Text);
      idudpserver1.Binding.ip:='0.0.0.0';
      idudpserver1.Binding.Port:=strtoint(Edit_rx_port.Text);

      IdUDPServer1.Active:=true;
      IdUDPServer1.Active:=false;
      IdUDPServer1.Active:=true;

      form1.Caption:='Terminal '+verze_sw+' - '+verze_ini+' UDP pipojen';
      Button_UDP_On.Caption:='Odpojit';
      if ComboBox_pripojeni.itemindex=3 then Form_RX_TX.Add_Stav('UDP server pipojen');

end;

Procedure tform1.UDP_Disconnect;
begin
  ComboBox_pripojeni.Enabled:=true;
      Edit_tx_adr.Enabled:=true;
      Edit_tx_port.Enabled:=true;
      Edit_rx_port.Enabled:=true;

      label4.Enabled:=true;
      label5.Enabled:=true;

      label7.Enabled:=true;

      IdUDPServer1.Active:=false;
      form1.Caption:='Terminal '+verze_sw+' - '+verze_ini+' odpojen';
      Button_UDP_On.Caption:='Pipojit';
      if ComboBox_pripojeni.itemindex=3 then Form_RX_TX.Add_Stav('UDP server odpojen');
end;



Procedure tform1.TCP_S_Disconnect;

var
 i : Integer;
 AThread: TIdPeerThread;
begin

  ComboBox_pripojeni.Enabled:=true;
  Edit_TCP_S_port.Enabled:=true;

  with IdTCPServer1.Threads.LockList do
  try
    for i := Count - 1 downto 0 do
      begin
        AThread := Items[i];
        if AThread = nil then Continue;
        AThread.Connection.DisconnectSocket;
      end;
  finally
    IdTCPServer1.Threads.UnlockList;
    try
      IdTCPServer1.Active := false;
    except
 //     ExitProcess(0);
    end;
  end;

//  try
//     IdTCPServer1.Active:=false;
//  except
//  end;

//  try
//    label3.Caption:=inttostr(IdTCPServer1.Bindings.Count);
//  except
//  end;

  Button_TCP_S_On.Caption:='Pipojit';
end;

Procedure tform1.TCP_S_Connect;
begin
  ComboBox_pripojeni.Enabled:=false;
  Edit_TCP_S_port.Enabled:=false;

  IdTCPServer1.DefaultPort:=strtoint(Edit_TCP_S_port.Text);
  IdTCPServer1.Active:=true;
  Button_TCP_S_On.Caption:='Odpojit';
end;

Procedure tform1.TCP_C_Disconnect;
begin
  IdTCPClient1.disConnect;

  label11.Enabled:=true;
  label2.Enabled:=true;
  Edit_tcp_k_addr.Enabled:=true;
  Edit_tcp_k_port.Enabled:=true;
  kill_eth:=true;
  Button_TCP_C_On.Caption:='Pipojit';
end;

Procedure tform1.TCP_C_Connect;
begin
  kill_eth:=false;
  IdTCPClient1.Host:=Edit_tcp_k_addr.text;
  IdTCPClient1.port:=strtoint(Edit_tcp_k_port.text);
  IdTCPClient1.Connect(1000);

end;

Procedure tform1.ICMP_Disconnect;
begin
  ICMP_connected:=false;
  ComboBox_pripojeni.Enabled:=true;

  form1.Caption:='Terminal '+verze_sw+' - '+verze_ini+' odpojen';
  if ComboBox_pripojeni.itemindex=4 then Form_RX_TX.Add_Stav('ICMP odpojen');
  Button_ICMP_On.Caption:='Zapnout';
end;

Procedure tform1.ICMP_Connect;
begin
  ICMP_connected:=true;
  ComboBox_pripojeni.Enabled:=false;
  
  form1.Caption:='Terminal '+verze_sw+' - '+verze_ini+' ICMP pipojen';
  if ComboBox_pripojeni.itemindex=4 then Form_RX_TX.Add_Stav('ICMP aktivn');
  Button_ICMP_On.Caption:='Vypnout';
end;

procedure TForm1.IdUDPServer1UDPRead(Sender: TObject; AData: TStream;
  ABinding: TIdSocketHandle);
var
  Buffer: Array [0..2047] of Byte;
  count: Integer;
  PeerIP: String;
  PeerPort: Integer;
  s, ss, t, a, m, h, st: String;
  i, n, volej_makro : Integer;
begin


  PeerIP := ABinding.PeerIP;
  PeerPort:= ABinding.PeerPort;
  count := AData.Size;
  if count > Length(Buffer) then begin
    exit;
  end;

  // prijata data
  AData.Read(Buffer, count);
  s:='';
  for i:=0 to count-1 do
    begin
      s:=s+char(Buffer[i]);
    end;
  Parse_RX(s, PeerIP+':'+inttostr(PeerPort));
end;

procedure tform1.Parse_RX(s: string; z:string);
var
  ss, t, a, m, h, st: String;
  i, n, volej_makro : Integer;
begin

  volej_makro:=-1;

  st:='';
  for i:=1 to length(s) do
    if ord(s[i])>31 then st:=st+s[i]
    else st:=st+'<'+ascii_names[ord(s[i])].name+'>';


  h:='';
  if Form_RX_TX.CheckBox_hex.Checked then
    begin
      for i:=1 to length(s) do
        h:=h+' '+inttohex(ord(s[i]),2);
    end;





  // info o pouzitych filtrech
  m:='';

  // porovanm se zapnutymi filtry
  for i:=1 to Form_RX_filtr.filtr_framecount do
    if Form_RX_filtr.filtr_frames[i].CheckBox_filtr_active.Checked then
      begin

        // prekonvertuju filtr
        if Form_RX_filtr.filtr_frames[i].CheckBox_filtr_hex.Checked then
          ss:=form1.hextostr(Form_RX_filtr.filtr_frames[i].Edit_filtr.Text)
        else
          ss:=form1.wildtostr(Form_RX_filtr.filtr_frames[i].Edit_filtr.Text);

        // porovnam zacatek retezce
        if ss=LeftStr(s,length(ss)) then
          begin
            // najdu odpovidajici makro
            for n:=1 to Form_TX.TX_framecount do
              begin
                // odeslu makro
                if Form_RX_filtr.filtr_frames[i].ComboBox_filtr_macro.Text=
                    Form_TX.TX_frames[n].Edit_popis.Text then
                  begin
                    volej_makro:=n;
                    // ulozim info o volanem makru
                    if Form_RX_TX.CheckBox_makro.Checked then
                      m:=m+'/ Vol makro: '+Form_RX_filtr.filtr_frames[i].ComboBox_filtr_macro.Text+' ';
                  end;
              end;
          end;
      end;


  if Form_RX_TX.CheckBox_time.Checked then
    t:=timetostr(now)+' '
  else
    t:='';

  if Form_RX_TX.CheckBox_adr.Checked then
    a:='z: '+z+' '
  else
    a:='';

  if Form_RX_TX.CheckBox_rx.Checked then
    begin
      form_rx_TX.RichEdit_mix.SelAttributes.Color:=clblack;
      form_rx_TX.RichEdit_mix.SelAttributes.Name:='MS Sans Serif';
      form_rx_TX.RichEdit_mix.Lines.Add(t+'Pijal data '+a+m+':');
      form_rx_TX.RichEdit_mix.SelAttributes.Color:=clRed;
      form_rx_TX.RichEdit_mix.SelAttributes.name:='Courier';
      form_rx_TX.RichEdit_mix.Lines.Add('  '+st);
      form_rx_TX.RichEdit_mix.SelAttributes.Color:=clRed;
      form_rx_TX.RichEdit_mix.SelAttributes.name:='Courier';
      if Form_RX_TX.CheckBox_hex.Checked then
        form_rx_TX.RichEdit_mix.Lines.Add(' '+h);
      form_rx_TX.RichEdit_mix.SelAttributes.Color:=clRed;
      form_rx_TX.RichEdit_mix.SelAttributes.name:='Courier';
      Form_RX_TX.label_lines.Caption:=inttostr(form_rx_TX.RichEdit_mix.lines.Count);
    end;

  // okno form_rxw
  if form_rxw.RichEdit_rx.Lines.Count=0 then form_rxw.RichEdit_rx.Lines.add('');
  case form_rxw.ComboBox_format.ItemIndex of
    0: begin  // formatovat
            i:=1;
            while i<=length(s) do
              begin
                if s[i]>=' ' then
                  form_rxw.RichEdit_rx.Lines[form_rxw.RichEdit_rx.Lines.Count-1]:=
                    form_rxw.RichEdit_rx.Lines[form_rxw.RichEdit_rx.Lines.Count-1]+(s[i])
                else if (s[i]=#$0d)or((s[i]=#$0a)and
                          (form_rxw.RichEdit_rx.Lines[form_rxw.RichEdit_rx.Lines.Count-1]<>''))  then
                   form_rxw.RichEdit_rx.Lines.add('');
                i:=i+1;
              end;
    end;
    1: begin  // neviditelne

      form_rxw.RichEdit_rx.Lines[form_rxw.RichEdit_rx.Lines.Count-1]:=
              form_rxw.RichEdit_rx.Lines[form_rxw.RichEdit_rx.Lines.Count-1]+(st);
    end;
    2: begin  // neviditelne podle bloku

      form_rxw.RichEdit_rx.Lines.add(st);
    end;
    3: begin  // sestnactkove

      form_rxw.RichEdit_rx.Lines[form_rxw.RichEdit_rx.Lines.Count-1]:=
              form_rxw.RichEdit_rx.Lines[form_rxw.RichEdit_rx.Lines.Count-1]+(h);
    end;
    4: begin  // sestnactkove podle bloku

      form_rxw.RichEdit_rx.Lines.add(h);
    end;

  end;

  if volej_makro>-1 then Form_TX.TX_frames[volej_makro].Button_send.Click;
end;

procedure TForm1.Button_tx_showClick(Sender: TObject);
begin
  form_tx.show;
end;

procedure TForm1.Button_UDP_OnClick(Sender: TObject);
var bd:tidsockethandle;
begin
  RS232_Disconnect;
  TCP_S_Disconnect;
  TCP_C_Disconnect;
  ICMP_Disconnect;

  if IdUDPServer1.Active then
    UDP_Disconnect
  else
    UDP_Connect;

end;


procedure TForm1.FormActivate(Sender: TObject);
var ini:tinifile;
    n: integer;
begin

  if not setup_done then
    begin
    


      try
        ini:=tinifile.create(ini_filename);

        form1.Left:=ini.readinteger('Form_main','Left',0);
        form1.top:=ini.readinteger('Form_main','top',0);
        form1.width:=ini.readinteger('Form_main','width',500);
        form1.height:=ini.readinteger('Form_main','height',200);
        case ini.readinteger('Form_main','WindowState',2) of
          0: form1.WindowState:=wsNormal;
          1: form1.WindowState:=wsMinimized;
          2: form1.WindowState:=wsMaximized;
        end; // case

        form1.ComboBox_pripojeni.ItemIndex:=ini.readinteger('Form_main','connection',0);
        ComboBox_pripojeniChange(self);

        form1.Edit_tx_adr.text:=ini.readstring('Form_main','tx_adr','10.0.0.7');
        form1.Edit_tx_port.text:=ini.readstring('Form_main','tx_port','9876');
        form1.Edit_rx_port.text:=ini.readstring('Form_main','rx_port','9876');

        form1.Edit_icmp_a.text:=ini.readstring('Form_main','icmp_a','192.198.1.1');
        form1.Edit_TCP_S_port.text:=ini.readstring('Form_main','tcp_s_p','666');
        form1.Edit_tcp_k_addr.text:=ini.readstring('Form_main','tcp_c_a','192.198.1.1');
        form1.Edit_tcp_k_port.text:=ini.readstring('Form_main','tcp_c_p','555');
        ComboBox_COM_port.ItemIndex:=ini.readinteger('Form_main','com_port',0);
        ComboBox_baud.text:=ini.readstring('Form_main','com_baud','115200');
        ComboBox_bits.ItemIndex:=ini.readinteger('Form_main','com_bits',3);
        ComboBox_parity.ItemIndex:=ini.readinteger('Form_main','com_parity',0);
        ComboBox_stop.ItemIndex:=ini.readinteger('Form_main','com_stop',0);

        Form_RXW.Left:=ini.readinteger('Form_RXW','Left',500);
        Form_RXW.top:=ini.readinteger('Form_RXW','top',80);
        Form_RXW.width:=ini.readinteger('Form_RXW','width',500);
        Form_RXW.height:=ini.readinteger('Form_RXW','height',200);
        Form_RXW.Visible:=ini.readbool('Form_RXW','visible',true);
        Form_RXW.ComboBox_format.ItemIndex:=ini.readinteger('Form_RXW','format',0);

        Form_TXW.Left:=ini.readinteger('Form_TXW','Left',500);
        Form_TXW.top:=ini.readinteger('Form_TXW','top',80);
        Form_TXW.width:=ini.readinteger('Form_TXW','width',500);
        Form_TXW.height:=ini.readinteger('Form_TXW','height',200);
        Form_TXW.Visible:=ini.readbool('Form_TXW','visible',true);
        Form_TXW.ComboBox_format.ItemIndex:=ini.readinteger('Form_TXW','format',0);

        Form_RX_TX.Left:=ini.readinteger('Form_RX_TX','Left',500);
        Form_RX_TX.top:=ini.readinteger('Form_RX_TX','top',80);
        Form_RX_TX.width:=ini.readinteger('Form_RX_TX','width',500);
        Form_RX_TX.height:=ini.readinteger('Form_RX_TX','height',200);
        Form_RX_TX.Visible:=ini.readbool('Form_RX_TX','visible',true);
        Form_RX_TX.CheckBox_rx.checked:=ini.readbool('Form_RX_TX','show_rx',false);
        Form_RX_TX.CheckBox_tx.checked:=ini.readbool('Form_RX_TX','show_tx',false);
        Form_RX_TX.CheckBox_time.checked:=ini.readbool('Form_RX_TX','show_time',false);
        Form_RX_TX.CheckBox_adr.checked:=ini.readbool('Form_RX_TX','show_adr',false);
        Form_RX_TX.CheckBox_makro.checked:=ini.readbool('Form_RX_TX','show_makro',false);
        Form_RX_TX.CheckBox_hex.checked:=ini.readbool('Form_RX_TX','show_hex',false);
        Form_RX_TX.CheckBox_stavy.checked:=ini.readbool('Form_RX_TX','show_stavy',false);

        Form_TX.Left:=ini.readinteger('Form_TX','Left',0);
        Form_TX.top:=ini.readinteger('Form_TX','top',80);
        Form_TX.width:=ini.readinteger('Form_TX','width',500);
        Form_TX.height:=ini.readinteger('Form_TX','height',200);
        Form_TX.Visible:=ini.readbool('Form_TX','visible',true);

        form_TX.TX_framecount:=ini.readinteger('Form_TX','TX_framecount',1);

        if form_TX.TX_framecount<1 then form_TX.TX_framecount:=1;

//        Form_TX.Frame_TX_main1.height:=23*form_TX.TX_framecount;

        Form_TX.Constraints.MaxHeight:=23*form_TX.TX_framecount+100;
        for n:=1 to form_TX.TX_framecount do
          begin
            form_TX.TX_frames[n]:=TFrame_tx.Create(Form_TX.Frame_TX_main1);

            form_TX.TX_frames[n].Name:='tx_frame_'+inttostr(n);
            form_TX.TX_frames[n].Edit_popis.tag:=n;
            form_TX.TX_frames[n].Parent:=Form_TX.Frame_TX_main1;

            form_TX.TX_frames[n].left:=0;
            form_TX.TX_frames[n].top:=n*23-23;
            form_TX.TX_frames[n].width:=Form_TX.Frame_TX_main1.clientwidth;
            form_TX.TX_frames[n].height:=23;

            form_TX.TX_frames[n].Anchors:=[akLeft,akRight,akTop];

            form_TX.TX_frames[n].visible:=true;

            Form_TX.TX_frames[n].Edit_popis.Text:=
              ini.readstring('Frame_TX_'+inttostr(n),'describe','tx_'+inttostr(n));
            Form_TX.TX_frames[n].Edit_data.Text:=
              ini.readstring('Frame_TX_'+inttostr(n),'data','data_'+inttostr(n));
            Form_TX.TX_frames[n].Edit_interval.Text:=
              ini.readstring('Frame_TX_'+inttostr(n),'interval',inttostr(n*1000));

          end;
        Form_TX.frame_TX_change(1);


        Form_RX_filtr.Left:=ini.readinteger('Form_RX_filtr','Left',0);
        Form_RX_filtr.top:=ini.readinteger('Form_RX_filtr','top',80);
        Form_RX_filtr.width:=ini.readinteger('Form_RX_filtr','width',500);
        Form_RX_filtr.height:=ini.readinteger('Form_RX_filtr','height',200);
        Form_RX_filtr.Visible:=ini.readbool('Form_RX_filtr','visible',true);

        Form_RX_filtr.filtr_framecount:=ini.readinteger('Form_RX_filtr','filtr_framecount',1);

        if Form_RX_filtr.filtr_framecount<1 then Form_RX_filtr.filtr_framecount:=1;

//        Form_TX.Frame_TX_main1.height:=23*form_TX.TX_framecount;

        Form_RX_filtr.Constraints.MaxHeight:=23*Form_RX_filtr.filtr_framecount+100;
        for n:=1 to Form_RX_filtr.filtr_framecount do
          begin
            Form_RX_filtr.filtr_frames[n]:=TFrame_filtr.Create(Form_RX_filtr.Frame_filtr_main1);

            Form_RX_filtr.filtr_frames[n].Name:='filtr_frame_'+inttostr(n);
            Form_RX_filtr.filtr_frames[n].Edit_filtr.tag:=n;
            Form_RX_filtr.filtr_frames[n].Parent:=Form_RX_filtr.Frame_filtr_main1;

            Form_RX_filtr.filtr_frames[n].left:=0;
            Form_RX_filtr.filtr_frames[n].top:=n*23-23;
            Form_RX_filtr.filtr_frames[n].width:=Form_RX_filtr.Frame_filtr_main1.clientwidth;
            Form_RX_filtr.filtr_frames[n].height:=23;

            Form_RX_filtr.filtr_frames[n].Anchors:=[akLeft,akRight,akTop];

            Form_RX_filtr.filtr_frames[n].visible:=true;

            Form_RX_filtr.filtr_frames[n].Edit_filtr.Text:=
              ini.readstring('Frame_filtr_'+inttostr(n),'filter','');

            Form_RX_filtr.filtr_frames[n].ComboBox_filtr_macro.Text:=
              ini.readstring('Frame_filtr_'+inttostr(n),'macro','');

            Form_RX_filtr.filtr_frames[n].CheckBox_filtr_active.Checked:=
              ini.readbool('Frame_filtr_'+inttostr(n),'active',false);

            Form_RX_filtr.filtr_frames[n].CheckBox_filtr_hex.Checked:=
              ini.readbool('Frame_filtr_'+inttostr(n),'hex',false);


          end;
        Form_RX_filtr.frame_filtr_change(1);

      finally
        ini.free;
      end;

      setup_done := true;
    end;

end;

procedure tform1.saveconfig;
var ini:tinifile;
    n: integer;
begin
      try
        ini:=tinifile.create(ini_filename);

        ini.writeinteger('Form_main','Left',form1.Left);
        ini.writeinteger('Form_main','top',form1.top);
        ini.writeinteger('Form_main','width',form1.width);
        ini.writeinteger('Form_main','height',form1.height);

        case form1.WindowState of
          wsNormal:     ini.writeinteger('Form_main','WindowState',0);
          wsMinimized:  ini.writeinteger('Form_main','WindowState',1);
          wsMaximized:  ini.writeinteger('Form_main','WindowState',2);
        end; // case

        ini.writeinteger('Form_main','connection',ComboBox_pripojeni.ItemIndex);

        ini.writestring('Form_main','tx_adr',form1.Edit_tx_adr.text);
        ini.writestring('Form_main','tx_port',form1.Edit_tx_port.text);
        ini.writestring('Form_main','rx_port',form1.Edit_rx_port.text);

        ini.writestring('Form_main','icmp_a',form1.Edit_icmp_a.text);
        ini.writestring('Form_main','tcp_s_p',form1.Edit_TCP_S_port.text);
        ini.writestring('Form_main','tcp_c_a',form1.Edit_tcp_k_addr.text);
        ini.writestring('Form_main','tcp_c_p',form1.Edit_tcp_k_port.text);
        ini.writeinteger('Form_main','com_port',ComboBox_COM_port.ItemIndex);
        ini.writestring('Form_main','com_baud',ComboBox_baud.text);
        ini.writeinteger('Form_main','com_bits',ComboBox_bits.ItemIndex);
        ini.writeinteger('Form_main','com_parity',ComboBox_parity.ItemIndex);
        ini.writeinteger('Form_main','com_stop',ComboBox_stop.ItemIndex);

        ini.writeinteger('Form_RXW','Left',Form_RXW.Left);
        ini.writeinteger('Form_RXW','top',Form_RXW.top);
        ini.writeinteger('Form_RXW','width',Form_RXW.width);
        ini.writeinteger('Form_RXW','height',Form_RXW.height);
        ini.writebool('Form_RXW','visible',Form_RXW.Visible);
        ini.writeinteger('Form_RXW','format',Form_RXW.ComboBox_format.ItemIndex);

        ini.writeinteger('Form_TXW','Left',Form_TXW.Left);
        ini.writeinteger('Form_TXW','top',Form_TXW.top);
        ini.writeinteger('Form_TXW','width',Form_TXW.width);
        ini.writeinteger('Form_TXW','height',Form_TXW.height);
        ini.writebool('Form_TXW','visible',Form_TXW.Visible);
        ini.writeinteger('Form_TXW','format',Form_TXW.ComboBox_format.ItemIndex);

        ini.writeinteger('Form_RX_TX','Left',Form_RX_TX.Left);
        ini.writeinteger('Form_RX_TX','top',Form_RX_TX.top);
        ini.writeinteger('Form_RX_TX','width',Form_RX_TX.width);
        ini.writeinteger('Form_RX_TX','height',Form_RX_TX.height);
        ini.writebool('Form_RX_TX','visible',Form_RX_TX.Visible);
        ini.writebool('Form_RX_TX','show_rx',Form_RX_TX.CheckBox_rx.checked);
        ini.writebool('Form_RX_TX','show_tx',Form_RX_TX.CheckBox_tx.checked);
        ini.writebool('Form_RX_TX','show_time',Form_RX_TX.CheckBox_time.checked);
        ini.writebool('Form_RX_TX','show_adr',Form_RX_TX.CheckBox_adr.checked);
        ini.writebool('Form_RX_TX','show_makro',Form_RX_TX.CheckBox_makro.checked);
        ini.writebool('Form_RX_TX','show_hex',Form_RX_TX.CheckBox_hex.checked);
        ini.writebool('Form_RX_TX','show_stavy',Form_RX_TX.CheckBox_stavy.checked);

        ini.writeinteger('Form_TX','Left',Form_TX.Left);
        ini.writeinteger('Form_TX','top',Form_TX.top);
        ini.writeinteger('Form_TX','width',Form_TX.width);
        ini.writeinteger('Form_TX','height',Form_TX.height);
        ini.writebool('Form_TX','visible',Form_TX.Visible);

        ini.writeinteger('Form_TX','TX_framecount',form_TX.TX_framecount);
        for n:=1 to form_TX.TX_framecount do
          begin
            ini.writestring('Frame_TX_'+inttostr(n),'describe',Form_TX.TX_frames[n].Edit_popis.Text);
            ini.writestring('Frame_TX_'+inttostr(n),'data',Form_TX.TX_frames[n].Edit_data.Text);
            ini.writestring('Frame_TX_'+inttostr(n),'interval',Form_TX.TX_frames[n].Edit_interval.Text);
          end;

        ini.writeinteger('Form_RX_filtr','Left',Form_RX_filtr.Left);
        ini.writeinteger('Form_RX_filtr','top',Form_RX_filtr.top);
        ini.writeinteger('Form_RX_filtr','width',Form_RX_filtr.width);
        ini.writeinteger('Form_RX_filtr','height',Form_RX_filtr.height);
        ini.writebool('Form_RX_filtr','visible',Form_RX_filtr.Visible);

        ini.writeinteger('Form_RX_filtr','filtr_framecount',Form_RX_filtr.filtr_framecount);
        for n:=1 to Form_RX_filtr.filtr_framecount do
          begin
            ini.writestring('Frame_filtr_'+inttostr(n),'filter',Form_RX_filtr.filtr_frames[n].Edit_filtr.Text);
            ini.writestring('Frame_filtr_'+inttostr(n),'macro',Form_RX_filtr.filtr_frames[n].ComboBox_filtr_macro.Text);
            ini.writebool('Frame_filtr_'+inttostr(n),'active',Form_RX_filtr.filtr_frames[n].CheckBox_filtr_active.Checked);
            ini.writebool('Frame_filtr_'+inttostr(n),'hex',Form_RX_filtr.filtr_frames[n].CheckBox_filtr_hex.Checked);
          end;

      finally
        ini.free;
      end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);

begin

  TCP_C_Disconnect;
//  TCP_S_Disconnect;
  ICMP_Disconnect;
  UDP_Disconnect;
  RS232_Disconnect;


  saveconfig;


end;


function tform1.hextostr(si:string):string;
var so, s : string;
    i,n: integer;
begin
  so:='';
  s:='$';

  for n:=1 to length(si) do
    begin
      if(si[n]<>' ')then s:=s+si[n];
      if(length(s)>2)then
        begin
          so:=so+char(strtoint(s));
          s:='$';
        end;
    end;
  result:= so;
end;

function tform1.wildtostr(si:string):string;
var so, s: string;
    i,n: integer;
begin
  i:=1;
  n:=1;
  so:='';

  while n<=length(si)do
    begin
      if si[n]='<' then
        begin
          n:=n+1;
          if si[n]='<' then so:=so+'<'  // <<
          else
            begin
              s:='';
              while (si[n]<>'>') do
                begin
                  s:=s+si[n];
                  n:=n+1;
                end;

                for i:=0 to sizeof(ascii_names)-1 do
                  if s=ascii_names[i].name then so:=so+char(ascii_names[i].value);

            end;
        end
      else if si[n]='$' then  // $xx - hexa hodnota
        begin
          n:=n+1;
          if si[n]='$' then so:=so+'$'   // $$
          else
            begin
              so:=so+char(strtoint('$'+si[n]+si[n+1]));
              n:=n+1;
            end;
        end
      else if si[n]='#' then  // #xxx - dec hodnota
        begin
          n:=n+1;
          if si[n]='#' then so:=so+'#'  // ##
          else
            begin
              so:=so+char(strtoint(si[n]+si[n+1]+si[n+2]));
              n:=n+2;
            end;
        end
      else                    // normalni znak
        begin
          so:=so+si[n];
        end;

      n:=n+1
    end;

  result:= so;
end;



procedure TForm1.Button3Click(Sender: TObject);
begin
  PopupMenu1.Popup(mouse.CursorPos.X,mouse.CursorPos.y);
end;

procedure TForm1.Npovda1Click(Sender: TObject);
begin
  form_help.show;
end;

procedure TForm1.Oprogramu1Click(Sender: TObject);
begin
  form_about.showmodal;
end;

procedure TForm1.Button_RX_filtrClick(Sender: TObject);
begin
  form_rx_filtr.show;
end;

procedure TForm1.IdTCPServer1Connect(AThread: TIdPeerThread);
begin
  if ComboBox_pripojeni.itemindex=2 then form_rx_TX.add_stav('TCP server pipojen...') ;
  idtcp_thread:=athread;

end;

procedure TForm1.IdTCPServer1Disconnect(AThread: TIdPeerThread);
begin
  if ComboBox_pripojeni.itemindex=2 then form_rx_TX.add_stav('TCP server odpojen...')
end;

procedure TForm1.Button_ICMP_OnClick(Sender: TObject);
begin
  RS232_Disconnect();
  TCP_S_Disconnect();
  TCP_C_Disconnect();
  UDP_Disconnect();

  if(ICMP_connected) then
    ICMP_Disconnect
  else
    ICMP_Connect;

end;

procedure TForm1.Button_TCP_C_OnClick(Sender: TObject);
begin
  RS232_Disconnect;
  TCP_S_Disconnect;
  ICMP_Disconnect;
  UDP_Disconnect;

  if IdTCPClient1.Connected then
    TCP_C_Disconnect
  else
    TCP_C_Connect;
end;

procedure TCommThread.Execute;
const

  Str: AnsiString = 'HELLO, THIS IS _ THRE_DED CLIENT!A';
var
  AByte: Byte;
  I: Integer;
//  Client: TIdTCPClient;
  var buf: array[0..100]of byte;
  c: char;

begin

    form1.eth_thread_running:=true;

    while true do
      begin
        try
//          application.ProcessMessages;
          if form1.kill_eth then exit;

          if form1.IdTCPClient1.Connected then
            begin
              try
                c:=form1.IdTCPClient1.ReadChar;
                while form1.semafor_stop_rx do;
                form1.rx_buff:=form1.rx_buff+c;
 //               form1.Prijmi_Znak(ord(c));
              except
              end;
            end
          else
            begin
              form1.eth_thread_running:=false;
              suspend;
            end;
          {
          form1.TCP_log('RX data: '+
            inttostr(buf[0])+' '+
            inttostr(buf[1])+' '+
            inttostr(buf[2])+' '+
            inttostr(buf[3])+' '+
            inttostr(buf[4])+' '+
            inttostr(buf[5])+' '+
            inttostr(buf[6])+' '+
            inttostr(buf[7])+' '); }
        except
          form1.IdTCPClient1.Free;
        end;
      end;
end;

procedure TForm1.Run_ETH_Thread(Sender: TObject);
begin
  ETHThread := TCommThread.Create(true);    { create suspended  secondprocess does not run yet }
  ETHThread.Priority := tpLower; { set the priority to lower than normal }
  ETHThread.Resume; { now run the thread }
end;


procedure TForm1.IdTCPClient1Connected(Sender: TObject);
begin


  label11.Enabled:=false;
  label2.Enabled:=false;
  Edit_tcp_k_addr.Enabled:=false;
  Edit_tcp_k_port.Enabled:=false;
  ComboBox_pripojeni.Enabled:=false;

  form1.Caption:='Terminal '+verze_sw+' - '+verze_ini+' TCP klient pipojen';
  Button_TCP_C_On.Caption:='Odpojit';
  if ComboBox_pripojeni.itemindex=1 then Form_RX_TX.Add_Stav('TCP klient pipojen');
  semafor_stop_rx:=false;
  old_length_rx_buff:=0;
  Run_ETH_Thread(self);

end;

procedure TForm1.IdTCPClient1Disconnected(Sender: TObject);
begin


  label11.Enabled:=true;
  label2.Enabled:=true;
  Edit_tcp_k_addr.Enabled:=true;
  Edit_tcp_k_port.Enabled:=true;
  ComboBox_pripojeni.Enabled:=true;
  form1.Caption:='Terminal '+verze_sw+' - '+verze_ini+' odpojen';

  Button_TCP_C_On.Caption:='Pipojit';
  if ComboBox_pripojeni.itemindex=1 then Form_RX_TX.Add_Stav('TCP klient odpojen');

end;

procedure TForm1.ApdComPort1PortClose(Sender: TObject);
begin
  if ComboBox_pripojeni.itemindex=0 then
    begin
      ComboBox_pripojeni.Enabled:=true;
      ComboBox_COM_port.Enabled:=true;
      Button_detect.Enabled:=true;
      ComboBox_baud.Enabled:=true;
//      ComboBox_bits.Enabled:=false;
//      ComboBox_parity.Enabled:=false;
//      ComboBox_stop.Enabled:=false;

      form1.Caption:='Terminal '+verze_sw+' - '+verze_ini+' odpojen';

      form_rx_TX.add_stav('COM'+inttostr(ApdComPort1.ComNumber)+' odpojen...')
    end;
end;

procedure TForm1.ApdComPort1PortOpen(Sender: TObject);
begin
  if ComboBox_pripojeni.itemindex=0 then
    begin
      ComboBox_pripojeni.Enabled:=false;
      ComboBox_COM_port.Enabled:=false;
      Button_detect.Enabled:=false;
      ComboBox_baud.Enabled:=false;
      ComboBox_bits.Enabled:=false;
      ComboBox_parity.Enabled:=false;
      ComboBox_stop.Enabled:=false;

      form1.Caption:='Terminal '+verze_sw+' - '+verze_ini+' RS232 pipojen';

      form_rx_TX.add_stav('COM'+inttostr(ApdComPort1.ComNumber)+' pipojen...')
    end;
end;

procedure TForm1.ApdComPort1TriggerAvail(CP: TObject; Count: Word);
var s:string;
    n:integer;
begin
  s:='';
  for n:=1 to count do s:=s+ApdComPort1.GetChar;
  Parse_RX(s,'COM'+inttostr(ApdComPort1.ComNumber));
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if ComboBox_COM_port.Items.Count=0 then
    Button_detectClick(self);

end;

procedure TForm1.Npovda3Click(Sender: TObject);
begin
  form_help.show;
end;

procedure TForm1.Oprogramu2Click(Sender: TObject);
begin
  form_about.showmodal;
end;

procedure TForm1.Button_RS232_OnClick(Sender: TObject);
begin
  TCP_C_Disconnect;
  TCP_S_Disconnect;
  ICMP_Disconnect;
  UDP_Disconnect;

  if ApdComPort1.Open then
    RS232_Disconnect
  else
    RS232_Connect;
end;

Procedure TForm1.RS232_Disconnect;
begin
  ApdComPort1.Open:=false;
  Button_RS232_On.Caption:='Pipojit';
end;

Procedure TForm1.RS232_Connect;
begin
  ApdComPort1.ComNumber:=strtoint(copy(ComboBox_COM_port.text,4,3));
  ApdComPort1.Baud:=strtoint(ComboBox_baud.Text);
  ApdComPort1.DataBits:=strtoint(ComboBox_bits.Text);

//  ApdComPort1.Parity:=strtoint(ComboBox_baud.Text);
//  ApdComPort1.StopBits:=strtoint(ComboBox_bits.Text);

  ApdComPort1.Open:=true;
  Button_RS232_On.Caption:='Odpojit';
end;

procedure TForm1.Button_detectClick(Sender: TObject);
var n:integer;
begin

  ComboBox_COM_port.Clear;
  if ApdComPort1.PromptForPort then form1.ApdComPort1.PromptForPort:=false;

  for n:=0 to 255 do
    try
      ApdComPort1.ComNumber:=n;
      ApdComPort1.Open:=true;
      if ApdComPort1.Open then ComboBox_COM_port.Items.Add('COM'+inttostr(n));
    except
    end;

  ApdComPort1.PromptForPort:=true;
  if ComboBox_COM_port.Items.Count>0 then ComboBox_COM_port.ItemIndex:=0;

end;


procedure tform1.Button_TCP_S_OnClick(Sender: TObject);
begin
  RS232_Disconnect;
  TCP_C_Disconnect;
  ICMP_Disconnect;
  UDP_Disconnect;


  if not form1.IdTCPServer1.Active then
    TCP_S_Connect
//  else if idtcp_thread=nil then
//    TCP_S_Connect
//  else if not idtcp_thread.Connection.Connected then
//    TCP_S_Connect
  else
    TCP_S_DisConnect;
end;

procedure TForm1.Makrakodesln1Click(Sender: TObject);
begin
  form_tx.show;
end;

procedure TForm1.Pijmacfiltry1Click(Sender: TObject);
begin
  form_rx_filtr.show;
end;

procedure TForm1.Stavyadata1Click(Sender: TObject);
begin
  form_rx_TX.show;
end;

procedure TForm1.ComboBox_pripojeniChange(Sender: TObject);
begin
  case ComboBox_pripojeni.ItemIndex of
    0:  // RS232
      begin
        Panel_RS.Visible:=true;
        Panel_TCP_C.Visible:=false;
        Panel_TCP_S.Visible:=false;
        Panel_UDP.Visible:=false;
        Panel_ICMP.Visible:=false;
      end;
    1:  // TCP klient
      begin
        Panel_RS.Visible:=false;
        Panel_TCP_C.Visible:=true;
        Panel_TCP_S.Visible:=false;
        Panel_UDP.Visible:=false;
        Panel_ICMP.Visible:=false;
      end;
    2:  // TCP server
      begin
        Panel_RS.Visible:=false;
        Panel_TCP_C.Visible:=false;
        Panel_TCP_S.Visible:=true;
        Panel_UDP.Visible:=false;
        Panel_ICMP.Visible:=false;
      end;
    3:  // UDP
      begin
        Panel_RS.Visible:=false;
        Panel_TCP_C.Visible:=false;
        Panel_TCP_S.Visible:=false;
        Panel_UDP.Visible:=true;
        Panel_ICMP.Visible:=false;
      end;
    4:  // ICMP
      begin
        Panel_RS.Visible:=false;
        Panel_TCP_C.Visible:=false;
        Panel_TCP_S.Visible:=false;
        Panel_UDP.Visible:=false;
        Panel_ICMP.Visible:=true;
      end;


  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox_pripojeniChange(self);


  ini_filename:=ExtractFilePath(Application.ExeName)+'default.ini';

  verze_ini:='';

  idtcp_thread:=nil;

  Panel_RS.Top:=0;
  Panel_TCP_S.Top:=0;
  Panel_TCP_C.Top:=0;
  Panel_UDP.Top:=0;
  Panel_ICMP.Top:=0;

  Constraints.MaxHeight:=81;
  Constraints.MinHeight:=81;

end;

procedure TForm1.Timer_rxTimer(Sender: TObject);
var l:integer;
begin
  semafor_stop_rx:=true;
//  application.ProcessMessages;

  l:=length(rx_buff);
  if (l=old_length_rx_buff)and(l>0) then // od posledna neprisly zadny dalsi data
    begin
      Parse_RX(rx_buff,'TCP-IP :'+inttostr(500));
      rx_buff:='';
      l:=0;
    end;
  semafor_stop_rx:=false;

  old_length_rx_buff:=l;

end;

procedure TForm1.IdIcmpClient1Reply(ASender: TComponent;
  const AReplyStatus: TReplyStatus);
  var s: string;
begin
  if AReplyStatus.ReplyStatusType=rsEcho then
    begin
      s:= copy(IdIcmpClient1.ReplyData,1,AReplyStatus.BytesReceived-40);

      Parse_RX(s, 'ICMP '+AReplyStatus.FromIpAddress+' - '+inttostr(AReplyStatus.BytesReceived-40)+'bajt');
    end
  else
    begin
      form_rx_TX.RichEdit_mix.SelAttributes.Color:=clblack;
      form_rx_TX.RichEdit_mix.Lines.add('CHYBA - nepila odpov.')
    end;
end;

procedure TForm1.IdTCPServer1Execute(AThread: TIdPeerThread);
var
    c: char;
begin
    c:=AThread.Connection.ReadChar; // skip $02
    while form1.semafor_stop_rx do;
    form1.rx_buff:=form1.rx_buff+c;
//    AThread.Connection.Write('odeslano');
    
end;

procedure TForm1.Pijatdata1Click(Sender: TObject);
begin
  form_rxw.show;
end;

procedure TForm1.Odeslandata1Click(Sender: TObject);
begin
  form_TXw.show;
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Otevtnastaven1Click(Sender: TObject);
var n: integer;
begin
  if OpenDialog1.Execute then
    begin


      ini_filename:=OpenDialog1.filename;
      verze_ini:=copy(ExtractFileName(ini_filename), 0, length(ExtractFileName(ini_filename))-4)+' - ';

      RS232_Disconnect;
      TCP_S_Disconnect;
      TCP_C_Disconnect;
      ICMP_Disconnect;
      UDP_Disconnect;

      for n:=1 to form_tx.TX_framecount do form_tx.TX_frames[n].Destroy;
      form_tx.TX_framecount:=0;

      for n:=1 to Form_RX_filtr.filtr_framecount do Form_RX_filtr.filtr_frames[n].Destroy;
      Form_RX_filtr.filtr_framecount:=0;

      setup_done:=false;
      FormActivate(self);
    end;
end;

procedure TForm1.Ulozitnastaven1Click(Sender: TObject);
begin
  if not SaveDialog1.Execute then exit;

  if fileexists(savedialog1.FileName) then
    if MessageDlg(Format('Pepsat existujc soubor? %s', [savedialog1.FileName]),
        mtConfirmation, mbYesNoCancel, 0) <> idYes then Exit;

        
  ini_filename:=savedialog1.FileName;

  verze_ini:=copy(ExtractFileName(ini_filename), 0, length(ExtractFileName(ini_filename))-4)+' - ';

  RS232_Disconnect;
  TCP_S_Disconnect;
  TCP_C_Disconnect;
  ICMP_Disconnect;
  UDP_Disconnect;

  saveconfig;

end;

end.
